/*
 * 商学院签到数据
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class SchoolSignInDataController : BaseController
    {
        public SchoolSignInDataController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商学院签到数据列表

        /// <summary>
        /// 根据条件查询商学院签到数据列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(SchoolSignInData data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询商学院签到数据列表

        /// <summary>
        /// 商学院签到数据列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(SchoolSignInData data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();



            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolSignInData", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["RingFlagName"] = dic["RingFlag"].ToString() == "1" ? "是" : "否";

            }
            return Json(obj);
        }

        #endregion

        #region 增加商学院签到数据

        /// <summary>
        /// 增加或修改商学院签到数据信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加商学院签到数据

        /// <summary>
        /// 增加或修改商学院签到数据信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(SchoolSignInData data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("TotalDays", data.TotalDays); //当月签到天数
            Fields.Add("ContinueDays", data.ContinueDays); //连续签到天数
            Fields.Add("RingFlag", data.RingFlag); //签到提醒

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Add("SchoolSignInData", Fields, 0);
            AddSysLog(data.Id.ToString(), "SchoolSignInData", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改商学院签到数据

        /// <summary>
        /// 增加或修改商学院签到数据信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            SchoolSignInData editData = db.SchoolSignInData.FirstOrDefault(m => m.Id == Id) ?? new SchoolSignInData();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商学院签到数据

        /// <summary>
        /// 增加或修改商学院签到数据信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(SchoolSignInData data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("TotalDays", data.TotalDays); //当月签到天数
            Fields.Add("ContinueDays", data.ContinueDays); //连续签到天数
            Fields.Add("RingFlag", data.RingFlag); //签到提醒

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("SchoolSignInData", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "SchoolSignInData", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除商学院签到数据信息

        /// <summary>
        /// 删除商学院签到数据信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInData", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("SchoolSignInData", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInData", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("SchoolSignInData", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolSignInData", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("SchoolSignInData", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Sort("SchoolSignInData", Sort, Id);

            AddSysLog(Id.ToString(), "SchoolSignInData", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.SchoolSignInData.Add(new SchoolSignInData()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "SchoolSignInData", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(SchoolSignInData data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("SchoolSignInData", Fields, "Id desc", "0", 1, 20000, condition, "TotalDays,ContinueDays,RingFlag", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["RingFlagName"] = dic["RingFlag"].ToString() == "1" ? "是" : "否";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("TotalDays", "当月签到天数");
            ReturnFields.Add("ContinueDays", "连续签到天数");
            ReturnFields.Add("RingFlag", "签到提醒");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "SchoolSignInData", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
